



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>设计模式总结篇系列：工厂方法模式（Factory Method）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">设计模式总结篇系列：工厂方法模式（Factory Method）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-12 02:56:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>工厂方法模式适合于对实现了同一接口或继承了同一父类的一些类进行实例的创建。一般是通过定义一个工厂类，并在其方法中实现对具有上述特点的类对象的创建。</strong></p>
<p>根据具体产生类对象的方法定义形式，又可以将其分为普通工厂方法模式、多个工厂方法模式和静态工厂方法模式。</p>
<p><strong>一、普通工厂方法模式：</strong></p>
<p>常见的经典写法如下（以发送邮件和短信为例）：</p>
<p>1.定义邮件类和短信类具有的共同接口：</p>
<div>
<pre class="prettyprint linenums"> interface Sender{

     public void sender();

 }</pre>
</div>
<p>2.定义邮件类和短信类：</p>
<div>
<pre class="prettyprint linenums"> class MailSender implements Sender{

     @Override<br />
     public void send() {<br />
         System.out.println("发送邮件");<br />
     }

 }</pre>
</div>
<div>
<pre class="prettyprint linenums"> class SmsSender implements Sender{

     @Override<br />
     public void send() {<br />
         System.out.println("发送短信");<br />
     }

 }</pre>
</div>
<p>3.定义工厂类：</p>
<div>
<pre class="prettyprint linenums"> class SenderFactory {

     public Sender produce(String type) {<br />
         if (type.equals("mail")) {<br />
             return new MailSender();<br />
         } else if (type.equals("sms")) {<br />
             return new SmsSender();<br />
         } else {<br />
             return null;<br />
         }<br />
     }

 }</pre>
</div>
<p>4.测试生成MailSender和SmsSender对象：</p>
<div>
<pre class="prettyprint linenums"> package com.qqyumidi;

 public class FactoryMethodTest {

     public static void main(String[] args) {<br />
         SenderFactory factory = new SenderFactory();<br />
         Sender mailSender = factory.produce("mail");<br />
         Sender smsSender = factory.produce("sms");<br />
     }

 }</pre>
</div>
<p><strong>二、多个工厂方法模式：</strong></p>
<p>将普通工厂模式中的工厂类中创建类的方法从依赖于参数判断改为直接针对每种对象各自定义一个生产方法。</p>
<p>具体代码如下:</p>
<div>
<pre class="prettyprint linenums"> class SenderFactory {

     public Sender produceMail(){<br />
         return new MailSender();<br />
     }

     public Sender produceSms(){<br />
         return new SmsSender();<br />
     }

 }</pre>
</div>
<p><strong>三、静态工厂方法模式：</strong></p>
<p>静态工厂方法模式与前面两种具体的方法定义不同在于方法被定义成静态的，这样可以不通过创建工厂实例就能直接获取到目标类的对象。</p>
<div>
<pre class="prettyprint linenums"> class SenderFactory {

     public static Sender produceMail(){<br />
         return new MailSender();<br />
     }

     public static Sender produceSms(){<br />
         return new SmsSender();<br />
     }

 }</pre>
</div>
<p>对于工厂方法模式，推荐使用第三种写法。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qy11njq.html">项目vue2&period;0仿外卖APP（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq15jr69.html">Shell入门教程：Shell变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96z0y3q.html">QQ左侧滑动显示之自定义属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/495lj6e8.html">使用Visual Studio Code开发AngularJS应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p46ek9.html">jquery 让select元素中的某个option被选中</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq13nvz8.html">Swift 通用类型和通用函数 &vert; Generic type and function</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9prl3zq.html">ASP&period;NET绑定控件语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdez46z9.html">mysql优化 mysql explain</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd6k1r8.html">css笔记&mdash;&mdash;小图标文字对齐中级解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/96olv2v9.html">&lpar;转载&rpar;Cocos2dx-OpenGL ES2&period;0教程&colon;初识MVP&lpar;3&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ywgx08.html">unix域套接字UDP网络编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz2k1e8.html">R语言重要数据集分析研究&mdash;&mdash;R语言数据集的字段含义</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgr3l48.html">Android设计开发笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kezoz9.html">错误： after element list</a>
		</li>
						<li><a href="https://www.batexi.com/a/9506yov8.html">&lbrack;再寄小读者之数学篇&rsqb;&lpar;2014-10-18 利用 Lagrange 中值定理求极限&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1pejjq.html">Python-uiautomator使用说明文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gg60eq.html">&period;net反编译的九款神器（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll1mg6q.html">canvas-6shadow&period;html</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1v02l9.html">音乐推荐与Audioscrobbler数据集</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2y52rq.html">AR外包&comma;就找北京动点软件，长年承接AR外包（案例丰富可签合同，内附案例演示）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlj6dee9.html">Codechef April Challenge 2019 游记</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojm0dpq.html">查看Oracle中存储过程长时间被卡住的原因</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ym2lz8.html">SpringCloud  在Feign上使用Hystrix（断路由）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj6rpk9.html">Prometheus 自定义exporter 监控key</a>
			</li>
						<li><a href="https://www.batexi.com/a/9geoome8.html">js 阻止事件执行</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj334z8.html">linux端安装Anaconda，方便远端访问jupyter</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz5wew8.html">CESSNA&colon; Resilient Edge-Computing</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz5wnw8.html">Ubuntu 16&period;04下sublime text3安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojm74lq.html">Spark入门PPT分享</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m6wvj8.html">&lbrack;WEB&rsqb;绕过安全狗与360PHP一句话的编写</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
